/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


class MonObjServ : public SvcServer {
  public :
  MonObjServ(int family=AF_INET) : SvcServer("MonObjServ", family) {};
  MonObjServ(char* n, int f) : SvcServer(n,f) {}


  public :
	
  void publish(char*& serv, char*& filtre, int& host, int& port) ;
  void subscript(char*& serv, char*& filtre,  char*& host,  int& port) ;
  void bench( OID& oid,  Page& page) ;

  class ReqRegister_publish {
    public :
    int dummy ;
    ReqRegister_publish(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_publish,0);
    } 
  } req_publish ;
  static void svc_publish(SvcSocket& s) {
    char* serv ;
    char* filtre ;
    int host ;
    int port ;
    s >> serv >> filtre >> host >> port ;
    ( ((MonObjServ*)(&s))->publish(serv, filtre, host, port) );
    delete serv ;
    delete filtre ;
  } ;

  class ReqRegister_subscript {
    public :
    int dummy ;
    ReqRegister_subscript(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_subscript,1);
    } 
  } req_subscript ;
  static void svc_subscript(SvcSocket& s) {
    char* serv ;
    char* filtre ;
    char* host ;
    int port ;
    s >> serv >> filtre ;
    ( ((MonObjServ*)(&s))->subscript(serv, filtre, host, port) );
    s << host << port << svcflush ;
    delete serv ;
    delete filtre ;
  } ;

  class ReqRegister_bench {
    public :
    int dummy ;
    ReqRegister_bench(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_bench,2);
    } 
  } req_bench ;
  static void svc_bench(SvcSocket& s) {
    OID oid ;
    Page page ;
    s >> oid ;
    ( ((MonObjServ*)(&s))->bench(oid, page) );
    s << page << svcflush ;
  } ;
} ;